.586
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include blank_dlg.inc

.code

start:
invoke GetModuleHandle,NULL
mov	hInstance,eax
invoke InitCommonControls
invoke DialogBoxParam,hInstance,IDD_DIALOG,NULL,addr DlgProc,NULL
invoke ExitProcess,0

DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  .if uMsg == WM_INITDIALOG
  
  .ELSEIF uMsg==WM_COMMAND
              ;; thx to ToutEnMasm and Relvinian
              mov eax,wParam  
              and eax,0FFFFh  ;needed and you have the low word
    .if eax == IDC_HIDE           
           call HideIcons
        .elseif eax == IDC_SHOW
              call    ShowIcons
    .endif 
          
	.elseif uMsg == WM_CLOSE 
	        EXIT:
		    invoke EndDialog,hWnd,0		             
  .endif
  xor eax, eax
  ret
DlgProc endp
GetDesktopListView  proc
    invoke  FindWindow, offset szProgman, NULL
    test    eax, eax
    jz      error
    invoke  FindWindowEx, eax, NULL, offset szSHELLDLL, NULL
    test    eax, eax
    jz      error
;;    mov     hDesktop, eax
    invoke  FindWindowEx, eax, NULL, offset szSysList, NULL
  error:
    ret
GetDesktopListView  endp

ShowIcons       proc
    call    GetDesktopListView
    test    eax, eax
    jz      error
    push    eax
    invoke  IsWindowVisible, eax
    .if eax == 0
        mov     IconState, 0
    .else
        mov     IconState, 1
    .endif
    pop     eax
    cmp     IconState, 1
    je      error
    invoke  ShowWindow, eax, SW_SHOW
    mov     IconState, 1
  error:
    ret
ShowIcons       endp

HideIcons       proc
    call    GetDesktopListView
    test    eax, eax
    jz      error
    push    eax
    invoke  IsWindowVisible, eax
    .if eax == 0
        mov     IconState, 0
    .else
        mov     IconState, 1
    .endif
    pop     eax
    cmp     IconState, 0
    je      error
    invoke  ShowWindow, eax, SW_HIDE
    mov     IconState, 0
  error:
    ret
HideIcons       endp

end start
